diff --git a/main.asm b/main.asm
index 0d81c646..b3e2074b 100755
--- a/main.asm
+++ b/main.asm
@@ -75537,7 +76831,7 @@ CeladonMartRoofBlocks: ; 485cc (12:45cc)
 CeladonMartElevator_h: ; 0x485f4 to 0x48600 (12 bytes) (bank=12) (id=127)
 	db $12 ; tileset
 	db CELADON_MART_ELEVATOR_HEIGHT, CELADON_MART_ELEVATOR_WIDTH ; dimensions (y, x)
-	dw CeladonMartElevatorBlocks, CeladonMartElevatorTexts, CeladonMartElevatorScript ; blocks, texts, scripts
+	dw CeladonMartElevatorBlocks, CeladonMartElevatorTextPointers, CeladonMartElevatorScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw CeladonMartElevatorObject ; objects
@@ -75580,7 +76874,7 @@ Func_48654: ; 48654 (12:4654)
 	ld hl, Func_7bf15
 	jp Bankswitch
 
-CeladonMartElevatorTexts: ; 4865c (12:465c)
+CeladonMartElevatorTextPointers: ; 4865c (12:465c)
 	dw CeladonMartElevatorText1
 
 CeladonMartElevatorText1: ; 4865e (12:465e)
@@ -75613,7 +76907,7 @@ CeladonMartElevatorBlocks: ; 48684 (12:4684)
 CeladonMansion1_h: ; 0x48688 to 0x48694 (12 bytes) (bank=12) (id=128)
 	db $13 ; tileset
 	db CELADON_MANSION_1_HEIGHT, CELADON_MANSION_1_WIDTH ; dimensions (y, x)
-	dw CeladonMansion1Blocks, CeladonMansion1Texts, CeladonMansion1Script ; blocks, texts, scripts
+	dw CeladonMansion1Blocks, CeladonMansion1TextPointers, CeladonMansion1Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw CeladonMansion1Object ; objects
@@ -75621,8 +76915,12 @@ CeladonMansion1_h: ; 0x48688 to 0x48694 (12 bytes) (bank=12) (id=128)
 CeladonMansion1Script: ; 48694 (12:4694)
 	jp EnableAutoTextBoxDrawing
 
-CeladonMansion1Texts: ; 48697 (12:4697)
-	dw CeladonMansion1Text1, CeladonMansion1Text2, CeladonMansion1Text3, CeladonMansion1Text4, CeladonMansion1Text5
+CeladonMansion1TextPointers: ; 48697 (12:4697)
+	dw CeladonMansion1Text1
+	dw CeladonMansion1Text2
+	dw CeladonMansion1Text3
+	dw CeladonMansion1Text4
+	dw CeladonMansion1Text5
 
 Func_486a1: ; 486a1 (12:46a1)
 	call PlayCry
@@ -75686,7 +76984,7 @@ CeladonMansion1Blocks: ; 48716 (12:4716)
 CeladonMansion2_h: ; 0x4872e to 0x4873a (12 bytes) (bank=12) (id=129)
 	db $13 ; tileset
 	db CELADON_MANSION_2_HEIGHT, CELADON_MANSION_2_WIDTH ; dimensions (y, x)
-	dw CeladonMansion2Blocks, CeladonMansion2Texts, CeladonMansion2Script ; blocks, texts, scripts
+	dw CeladonMansion2Blocks, CeladonMansion2TextPointers, CeladonMansion2Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw CeladonMansion2Object ; objects
@@ -75695,7 +76993,7 @@ CeladonMansion2Script: ; 4873a (12:473a)
 	call EnableAutoTextBoxDrawing
 	ret
 
-CeladonMansion2Texts: ; 4873e (12:473e)
+CeladonMansion2TextPointers: ; 4873e (12:473e)
 	dw CeladonMansion2Text1
 
 CeladonMansion2Text1: ; 48740 (12:4740)
@@ -75728,7 +77026,7 @@ CeladonMansion2Blocks: ; 4876c (12:476c)
 CeladonMansion3_h: ; 0x48784 to 0x48790 (12 bytes) (bank=12) (id=130)
 	db $13 ; tileset
 	db CELADON_MANSION_3_HEIGHT, CELADON_MANSION_3_WIDTH ; dimensions (y, x)
-	dw CeladonMansion3Blocks, CeladonMansion3Texts, CeladonMansion3Script ; blocks, texts, scripts
+	dw CeladonMansion3Blocks, CeladonMansion3TextPointers, CeladonMansion3Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw CeladonMansion3Object ; objects
@@ -75736,7 +77034,7 @@ CeladonMansion3_h: ; 0x48784 to 0x48790 (12 bytes) (bank=12) (id=130)
 CeladonMansion3Script: ; 48790 (12:4790)
 	jp EnableAutoTextBoxDrawing
 
-CeladonMansion3Texts: ; 48793 (12:4793)
+CeladonMansion3TextPointers: ; 48793 (12:4793)
 	dw ProgrammerText
 	dw GraphicArtistText
 	dw WriterText
@@ -75840,7 +77138,7 @@ CeladonMansion3Blocks: ; 48847 (12:4847)
 CeladonMansion4_h: ; 0x4885f to 0x4886b (12 bytes) (bank=12) (id=131)
 	db $13 ; tileset
 	db CELADON_MANSION_4_HEIGHT, CELADON_MANSION_4_WIDTH ; dimensions (y, x)
-	dw CeladonMansion4Blocks, CeladonMansion4Texts, CeladonMansion4Script ; blocks, texts, scripts
+	dw CeladonMansion4Blocks, CeladonMansion4TextPointers, CeladonMansion4Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw CeladonMansion4Object ; objects
@@ -75848,7 +77146,7 @@ CeladonMansion4_h: ; 0x4885f to 0x4886b (12 bytes) (bank=12) (id=131)
 CeladonMansion4Script: ; 4886b (12:486b)
 	jp EnableAutoTextBoxDrawing
 
-CeladonMansion4Texts: ; 4886e (12:486e)
+CeladonMansion4TextPointers: ; 4886e (12:486e)
 	dw CeladonMansion4Text1
 
 CeladonMansion4Text1: ; 48870 (12:4870)
@@ -75879,7 +77177,7 @@ CeladonMansion4Blocks: ; 48894 (12:4894)
 CeladonPokecenter_h: ; 0x488ac to 0x488b8 (12 bytes) (bank=12) (id=133)
 	db $06 ; tileset
 	db CELADON_POKECENTER_HEIGHT, CELADON_POKECENTER_WIDTH ; dimensions (y, x)
-	dw CeladonPokecenterBlocks, CeladonPokecenterTexts, CeladonPokecenterScript ; blocks, texts, scripts
+	dw CeladonPokecenterBlocks, CeladonPokecenterTextPointers, CeladonPokecenterScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw CeladonPokecenterObject ; objects
@@ -75888,8 +77186,11 @@ CeladonPokecenterScript: ; 488b8 (12:48b8)
 	call Func_22fa
 	jp EnableAutoTextBoxDrawing
 
-CeladonPokecenterTexts: ; 488be (12:48be)
-	dw CeladonPokecenterText1, CeladonPokecenterText2, CeladonPokecenterText3, CeladonPokecenterText4
+CeladonPokecenterTextPointers: ; 488be (12:48be)
+	dw CeladonPokecenterText1
+	dw CeladonPokecenterText2
+	dw CeladonPokecenterText3
+	dw CeladonPokecenterText4
 
 CeladonPokecenterText4: ; 488c6 (12:48c6)
 	db $f6
@@ -75927,7 +77228,7 @@ CeladonPokecenterObject: ; 0x488d2 (size=44)
 CeladonGym_h: ; 0x488fe to 0x4890a (12 bytes) (bank=12) (id=134)
 	db $07 ; tileset
 	db CELADON_GYM_HEIGHT, CELADON_GYM_WIDTH ; dimensions (y, x)
-	dw CeladonGymBlocks, CeladonGymTexts, CeladonGymScript ; blocks, texts, scripts
+	dw CeladonGymBlocks, CeladonGymTextPointers, CeladonGymScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw CeladonGymObject ; objects
@@ -75936,16 +77237,16 @@ CeladonGymScript: ; 4890a (12:490a)
 	ld hl, $d126
 	bit 6, [hl]
 	res 6, [hl]
-	call nz, CeladonGymScript_Unknown48927
+	call nz, CeladonGymScript_48927
 	call EnableAutoTextBoxDrawing
 	ld hl, CeladonGymTrainerHeaders
-	ld de, Unknown_4894e ; $494e
+	ld de, CeladonGymScriptPointers
 	ld a, [W_CELADONGYMCURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_CELADONGYMCURSCRIPT], a
 	ret
 
-CeladonGymScript_Unknown48927: ; 48927 (12:4927)
+CeladonGymScript_48927: ; 48927 (12:4927)
 	ld hl, Gym4CityName ; $4930
 	ld de, Gym4LeaderName ; $493d
 	jp LoadGymLeaderAndCityName
@@ -75963,8 +77264,13 @@ Func_48943: ; 48943 (12:4943)
 	ld [W_CURMAPSCRIPT], a
 	ret
 
-Unknown_4894e: ; 4894e (12:494e)
-INCBIN "baserom.gbc",$4894e,$48956 - $4894e
+CeladonGymScriptPointers: ; 4894e (12:494e)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
+	dw CeladonGymScript3
+
+CeladonGymScript3: ; 48956 (12:4956)
 	ld a, [W_ISINBATTLE] ; $d057
 	cp $ff
 	jp z, Func_48943
@@ -76002,8 +77308,18 @@ Func_48963: ; 48963 (12:4963)
 	set 0, [hl]
 	jp Func_48943
 
-CeladonGymTexts: ; 489a6 (12:49a6)
-	dw CeladonGymText1, CeladonGymText2, CeladonGymText3, CeladonGymText4, CeladonGymText5, CeladonGymText6, CeladonGymText7, CeladonGymText8, CeladonGymText9, TM21Text, TM21NoRoomText
+CeladonGymTextPointers: ; 489a6 (12:49a6)
+	dw CeladonGymText1
+	dw CeladonGymText2
+	dw CeladonGymText3
+	dw CeladonGymText4
+	dw CeladonGymText5
+	dw CeladonGymText6
+	dw CeladonGymText7
+	dw CeladonGymText8
+	dw CeladonGymText9
+	dw TM21Text
+	dw TM21NoRoomText
 
 CeladonGymTrainerHeaders: ; 489bc (12:49bc)
 CeladonGymTrainerHeader0: ; 489bc (12:49bc)
@@ -76069,7 +77385,7 @@ CeladonGymTrainerHeader7: ; 48a04 (12:4a04)
 	dw CeladonGymEndBattleText8 ; 0x4b26 TextEndBattle
 	dw CeladonGymEndBattleText8 ; 0x4b26 TextEndBattle
 
-db $ff
+	db $ff
 
 CeladonGymText1: ; 48a11 (12:4a11)
 	db $08 ; asm
@@ -76288,21 +77604,35 @@ CeladonGymBlocks: ; 48b84 (12:4b84)
 CeladonGameCorner_h: ; 0x48bb1 to 0x48bbd (12 bytes) (bank=12) (id=135)
 	db $12 ; tileset
 	db GAME_CORNER_HEIGHT, GAME_CORNER_WIDTH ; dimensions (y, x)
-	dw CeladonGameCornerBlocks, CeladonGameCornerTexts, CeladonGameCornerScript ; blocks, texts, scripts
+	dw CeladonGameCornerBlocks, CeladonGameCornerTextPointers, CeladonGameCornerScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw CeladonGameCornerObject ; objects
 
 CeladonGameCornerScript: ; 48bbd (12:4bbd)
-	call Unknown_48bcf
+	call CeladonGameCornerScript_48bcf
 	call Func_48bec
 	call EnableAutoTextBoxDrawing
-	ld hl, CeladonGameCornerScripts
+	ld hl, CeladonGameCornerScriptPointers
 	ld a, [W_CELADONGAMECORNERCURSCRIPT]
 	jp CallFunctionInTable
 
-Unknown_48bcf: ; 48bcf (12:4bcf)
-INCBIN "baserom.gbc",$48bcf,$48bec - $48bcf
+CeladonGameCornerScript_48bcf: ; 48bcf (12:4bcf)
+	ld hl, $d126
+	bit 6, [hl]
+	res 6, [hl]
+	ret z
+	call GenRandom
+	ld a, [$ffd3]
+	cp $7
+	jr nc, .asm_48be2
+	ld a, $8
+.asm_48be2
+	srl a
+	srl a
+	srl a
+	ld [$cd05], a
+	ret
 
 Func_48bec: ; 48bec (12:4bec)
 	ld hl, $d126
@@ -76318,24 +77648,89 @@ Func_48bec: ; 48bec (12:4bec)
 	ld a, $17
 	jp Predef
 
-INCBIN "baserom.gbc",$48c07,$48c12 - $48c07
+CeladonGameCornerScript_48c07: ; 48c07 (12:4c07)
+	xor a
+	ld [wJoypadForbiddenButtonsMask], a
+	ld [W_CELADONGAMECORNERCURSCRIPT], a
+	ld [W_CURMAPSCRIPT], a
+	ret
 
-CeladonGameCornerScripts: ; 48c12 (12:4c12)
-	dw CeladonGameCornerScript0, CeladonGameCornerScript1, CeladonGameCornerScript2
+CeladonGameCornerScriptPointers: ; 48c12 (12:4c12)
+	dw CeladonGameCornerScript0
+	dw CeladonGameCornerScript1
+	dw CeladonGameCornerScript2
 
 CeladonGameCornerScript0: ; 48c18 (12:4c18)
 	ret
 
 CeladonGameCornerScript1: ; 48c19 (12:4c19)
-INCBIN "baserom.gbc",$48c19,$48c5a - $48c19
+	ld a, [W_ISINBATTLE]
+	cp $ff
+	jp z, CeladonGameCornerScript_48c07
+	ld a, $f0
+	ld [wJoypadForbiddenButtonsMask], a
+	ld a, $d
+	ld [H_SPRITEHEIGHT], a
+	call DisplayTextID
+	ld a, $b
+	ld [H_SPRITEHEIGHT], a
+	call SetSpriteMovementBytesToFF
+	ld de, $4c5a
+	ld a, [$d361]
+	cp $6
+	jr nz, .asm_48c43
+	ld de, $4c63
+	jr .asm_48c4d
+.asm_48c43
+	ld a, [$d362]
+	cp $8
+	jr nz, .asm_48c4d
+	ld de, $4c63
+.asm_48c4d
+	ld a, $b
+	ld [H_DOWNARROWBLINKCNT2], a
+	call MoveSprite
+	ld a, $2
+	ld [W_CELADONGAMECORNERCURSCRIPT], a
+	ret
 
-INCBIN "baserom.gbc",$48c5a,$48c69 - $48c5a
+MovementData_48c5a: ; 48c5a (12:4c5a)
+	db $00,$C0,$C0,$40,$C0,$C0,$C0,$C0,$FF
+
+MovementData_48c63: ; 48c63 (12:4c63)
+	db $C0,$C0,$C0,$C0,$C0,$FF
 
 CeladonGameCornerScript2: ; 48c69 (12:4c69)
-INCBIN "baserom.gbc",$48c69,$48c8a - $48c69
+	ld a, [$d730]
+	bit 0, a
+	ret nz
+	xor a
+	ld [wJoypadForbiddenButtonsMask], a
+	ld a, $46
+	ld [$cc4d], a
+	ld a, $11
+	call Predef
+	ld hl, $d126
+	set 5, [hl]
+	set 6, [hl]
+	ld a, $0
+	ld [W_CELADONGAMECORNERCURSCRIPT], a
+	ret
 
-CeladonGameCornerTexts: ; 48c8a (12:4c8a)
-	dw CeladonGameCornerText1, CeladonGameCornerText2, CeladonGameCornerText3, CeladonGameCornerText4, CeladonGameCornerText5, CeladonGameCornerText6, CeladonGameCornerText7, CeladonGameCornerText8, CeladonGameCornerText9, CeladonGameCornerText10, CeladonGameCornerText11, CeladonGameCornerText12, CeladonGameCornerText13
+CeladonGameCornerTextPointers: ; 48c8a (12:4c8a)
+	dw CeladonGameCornerText1
+	dw CeladonGameCornerText2
+	dw CeladonGameCornerText3
+	dw CeladonGameCornerText4
+	dw CeladonGameCornerText5
+	dw CeladonGameCornerText6
+	dw CeladonGameCornerText7
+	dw CeladonGameCornerText8
+	dw CeladonGameCornerText9
+	dw CeladonGameCornerText10
+	dw CeladonGameCornerText11
+	dw CeladonGameCornerText12
+	dw CeladonGameCornerText13
 
 CeladonGameCornerText1: ; 48ca4 (12:4ca4)
 	TX_FAR _CeladonGameCornerText1
@@ -76786,7 +78181,7 @@ CeladonGameCornerBlocks: ; 49003 (12:5003)
 CeladonMart5_h: ; 0x4905d to 0x49069 (12 bytes) (bank=12) (id=136)
 	db $12 ; tileset
 	db CELADON_MART_5_HEIGHT, CELADON_MART_5_WIDTH ; dimensions (y, x)
-	dw CeladonMart5Blocks, CeladonMart5Texts, CeladonMart5Script ; blocks, texts, scripts
+	dw CeladonMart5Blocks, CeladonMart5TextPointers, CeladonMart5Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw CeladonMart5Object ; objects
@@ -76794,8 +78189,12 @@ CeladonMart5_h: ; 0x4905d to 0x49069 (12 bytes) (bank=12) (id=136)
 CeladonMart5Script: ; 49069 (12:5069)
 	jp EnableAutoTextBoxDrawing
 
-CeladonMart5Texts: ; 4906c (12:506c)
-	dw CeladonMart5Text1, CeladonMart5Text2, CeladonMart5Text3, CeladonMart5Text4, CeladonMart5Text5
+CeladonMart5TextPointers: ; 4906c (12:506c)
+	dw CeladonMart5Text1
+	dw CeladonMart5Text2
+	dw CeladonMart5Text3
+	dw CeladonMart5Text4
+	dw CeladonMart5Text5
 
 CeladonMart5Text1: ; 49076 (12:5076)
 	TX_FAR _CeladonMart5Text1
@@ -76837,7 +78236,7 @@ CeladonMart5Blocks: ; 490bc (12:50bc)
 CeladonPrizeRoom_h: ; 0x490e4 to 0x490f0 (12 bytes) (bank=12) (id=137)
 	db $12 ; tileset
 	db CELADONPRIZE_ROOM_HEIGHT, CELADONPRIZE_ROOM_WIDTH ; dimensions (y, x)
-	dw CeladonPrizeRoomBlocks, CeladonPrizeRoomTexts, CeladonPrizeRoomScript ; blocks, texts, scripts
+	dw CeladonPrizeRoomBlocks, CeladonPrizeRoomTextPointers, CeladonPrizeRoomScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw CeladonPrizeRoomObject ; objects
@@ -76845,8 +78244,12 @@ CeladonPrizeRoom_h: ; 0x490e4 to 0x490f0 (12 bytes) (bank=12) (id=137)
 CeladonPrizeRoomScript: ; 490f0 (12:50f0)
 	jp EnableAutoTextBoxDrawing
 
-CeladonPrizeRoomTexts: ; 490f3 (12:50f3)
-	dw CeladonPrizeRoomText1, CeladonPrizeRoomText2, CeladonPrizeRoomText3, CeladonPrizeRoomText3, CeladonPrizeRoomText3
+CeladonPrizeRoomTextPointers: ; 490f3 (12:50f3)
+	dw CeladonPrizeRoomText1
+	dw CeladonPrizeRoomText2
+	dw CeladonPrizeRoomText3
+	dw CeladonPrizeRoomText3
+	dw CeladonPrizeRoomText3
 
 CeladonPrizeRoomText1: ; 490fd (12:50fd)
 	TX_FAR _CeladonPrizeRoomText1
@@ -76885,7 +78288,7 @@ CeladonPrizeRoomBlocks: ; 49131 (12:5131)
 CeladonDiner_h: ; 0x49145 to 0x49151 (12 bytes) (bank=12) (id=138)
 	db $12 ; tileset
 	db CELADON_DINER_HEIGHT, CELADON_DINER_WIDTH ; dimensions (y, x)
-	dw CeladonDinerBlocks, CeladonDinerTexts, CeladonDinerScript ; blocks, texts, scripts
+	dw CeladonDinerBlocks, CeladonDinerTextPointers, CeladonDinerScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw CeladonDinerObject ; objects
@@ -76894,8 +78297,12 @@ CeladonDinerScript: ; 49151 (12:5151)
 	call EnableAutoTextBoxDrawing
 	ret
 
-CeladonDinerTexts: ; 49155 (12:5155)
-	dw CeladonDinerText1, CeladonDinerText2, CeladonDinerText3, CeladonDinerText4, CeladonDinerText5
+CeladonDinerTextPointers: ; 49155 (12:5155)
+	dw CeladonDinerText1
+	dw CeladonDinerText2
+	dw CeladonDinerText3
+	dw CeladonDinerText4
+	dw CeladonDinerText5
 
 CeladonDinerText1: ; 4915f (12:515f)
 	TX_FAR _CeladonDinerText1
@@ -76980,7 +78387,7 @@ CeladonDinerBlocks: ; 491ee (12:51ee)
 CeladonHouse_h: ; 0x49202 to 0x4920e (12 bytes) (bank=12) (id=139)
 	db $13 ; tileset
 	db CELADON_HOUSE_HEIGHT, CELADON_HOUSE_WIDTH ; dimensions (y, x)
-	dw CeladonHouseBlocks, CeladonHouseTexts, CeladonHouseScript ; blocks, texts, scripts
+	dw CeladonHouseBlocks, CeladonHouseTextPointers, CeladonHouseScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw CeladonHouseObject ; objects
@@ -76989,8 +78396,10 @@ CeladonHouseScript: ; 4920e (12:520e)
 	call EnableAutoTextBoxDrawing
 	ret
 
-CeladonHouseTexts: ; 49212 (12:5212)
-	dw CeladonHouseText1, CeladonHouseText2, CeladonHouseText3
+CeladonHouseTextPointers: ; 49212 (12:5212)
+	dw CeladonHouseText1
+	dw CeladonHouseText2
+	dw CeladonHouseText3
 
 CeladonHouseText1: ; 49218 (12:5218)
 	TX_FAR _CeladonHouseText1
@@ -77028,7 +78437,7 @@ CeladonHouseBlocks: ; 4924d (12:524d)
 CeladonHotel_h: ; 0x4925d to 0x49269 (12 bytes) (bank=12) (id=140)
 	db $06 ; tileset
 	db CELADONHOTEL_HEIGHT, CELADONHOTEL_WIDTH ; dimensions (y, x)
-	dw CeladonHotelBlocks, CeladonHotelTexts, CeladonHotelScript ; blocks, texts, scripts
+	dw CeladonHotelBlocks, CeladonHotelTextPointers, CeladonHotelScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw CeladonHotelObject ; objects
@@ -77036,8 +78445,10 @@ CeladonHotel_h: ; 0x4925d to 0x49269 (12 bytes) (bank=12) (id=140)
 CeladonHotelScript: ; 49269 (12:5269)
 	jp EnableAutoTextBoxDrawing
 
-CeladonHotelTexts: ; 4926c (12:526c)
-	dw CeladonHotelText1, CeladonHotelText2, CeladonHotelText3
+CeladonHotelTextPointers: ; 4926c (12:526c)
+	dw CeladonHotelText1
+	dw CeladonHotelText2
+	dw CeladonHotelText3
 
 CeladonHotelText1: ; 49272 (12:5272)
 	TX_FAR _CeladonHotelText1
@@ -77075,7 +78486,7 @@ CeladonHotelBlocks: ; 492a7 (12:52a7)
 MtMoonPokecenter_h: ; 0x492c3 to 0x492cf (12 bytes) (bank=12) (id=68)
 	db $06 ; tileset
 	db MT_MOON_POKECENTER_HEIGHT, MT_MOON_POKECENTER_WIDTH ; dimensions (y, x)
-	dw MtMoonPokecenterBlocks, MtMoonPokecenterTexts, MtMoonPokecenterScript ; blocks, texts, scripts
+	dw MtMoonPokecenterBlocks, MtMoonPokecenterTextPointers, MtMoonPokecenterScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw MtMoonPokecenterObject ; objects
@@ -77084,8 +78495,13 @@ MtMoonPokecenterScript: ; 492cf (12:52cf)
 	call Func_22fa
 	jp EnableAutoTextBoxDrawing
 
-MtMoonPokecenterTexts: ; 492d5 (12:52d5)
-	dw MtMoonPokecenterText1, MtMoonPokecenterText2, MtMoonPokecenterText3, MtMoonPokecenterText4, MtMoonPokecenterText5, MtMoonPokecenterText6
+MtMoonPokecenterTextPointers: ; 492d5 (12:52d5)
+	dw MtMoonPokecenterText1
+	dw MtMoonPokecenterText2
+	dw MtMoonPokecenterText3
+	dw MtMoonPokecenterText4
+	dw MtMoonPokecenterText5
+	dw MtMoonPokecenterText6
 
 MtMoonPokecenterText1: ; 492e1 (12:52e1)
 	db $ff
@@ -77197,7 +78613,7 @@ MtMoonPokecenterObject: ; 0x49376 (size=56)
 RockTunnelPokecenter_h: ; 0x493ae to 0x493ba (12 bytes) (id=81)
 	db $06 ; tileset
 	db ROCK_TUNNEL_POKECENTER_HEIGHT, ROCK_TUNNEL_POKECENTER_WIDTH ; dimensions (y, x)
-	dw RockTunnelPokecenterBlocks, RockTunnelPokecenterTexts, RockTunnelPokecenterScript ; blocks, texts, scripts
+	dw RockTunnelPokecenterBlocks, RockTunnelPokecenterTextPointers, RockTunnelPokecenterScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw RockTunnelPokecenterObject ; objects
@@ -77206,8 +78622,11 @@ RockTunnelPokecenterScript: ; 493ba (12:53ba)
 	call Func_22fa
 	jp EnableAutoTextBoxDrawing
 
-RockTunnelPokecenterTexts: ; 493c0 (12:53c0)
-	dw RockTunnelPokecenterText1, RockTunnelPokecenterText2, RockTunnelPokecenterText3, RockTunnelPokecenterText4
+RockTunnelPokecenterTextPointers: ; 493c0 (12:53c0)
+	dw RockTunnelPokecenterText1
+	dw RockTunnelPokecenterText2
+	dw RockTunnelPokecenterText3
+	dw RockTunnelPokecenterText4
 
 RockTunnelPokecenterText1: ; 493c8 (12:53c8)
 	db $ff
@@ -77245,7 +78664,7 @@ RockTunnelPokecenterObject: ; 0x493d4 (size=44)
 Route11Gate_h: ; 0x49400 to 0x4940c (12 bytes) (id=84)
 	db $0c ; tileset
 	db ROUTE_11_GATE_1F_HEIGHT, ROUTE_11_GATE_1F_WIDTH ; dimensions (y, x)
-	dw Route11GateBlocks, Route11GateTexts, Route11GateScript ; blocks, texts, scripts
+	dw Route11GateBlocks, Route11GateTextPointers, Route11GateScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw Route11GateObject ; objects
@@ -77253,7 +78672,7 @@ Route11Gate_h: ; 0x49400 to 0x4940c (12 bytes) (id=84)
 Route11GateScript: ; 4940c (12:540c)
 	jp EnableAutoTextBoxDrawing
 
-Route11GateTexts: ; 4940f (12:540f)
+Route11GateTextPointers: ; 4940f (12:540f)
 	dw Route11GateText1
 
 Route11GateText1: ; 49411 (12:5411)
@@ -77285,7 +78704,7 @@ Route11GateObject: ; 0x49416 (size=50)
 Route11GateUpstairs_h: ; 0x49448 to 0x49454 (12 bytes) (id=86)
 	db $0c ; tileset
 	db ROUTE_11_GATE_2F_HEIGHT, ROUTE_11_GATE_2F_WIDTH ; dimensions (y, x)
-	dw Route11GateUpstairsBlocks, Route11GateUpstairsTexts, Route11GateUpstairsScript ; blocks, texts, scripts
+	dw Route11GateUpstairsBlocks, Route11GateUpstairsTextPointers, Route11GateUpstairsScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw Route11GateUpstairsObject ; objects
@@ -77293,8 +78712,11 @@ Route11GateUpstairs_h: ; 0x49448 to 0x49454 (12 bytes) (id=86)
 Route11GateUpstairsScript: ; 49454 (12:5454)
 	jp DisableAutoTextBoxDrawing
 
-Route11GateUpstairsTexts: ; 49457 (12:5457)
-	dw Route11GateUpstairsText1, Route11GateUpstairsText2, Route11GateUpstairsText3, Route11GateUpstairsText4
+Route11GateUpstairsTextPointers: ; 49457 (12:5457)
+	dw Route11GateUpstairsText1
+	dw Route11GateUpstairsText2
+	dw Route11GateUpstairsText3
+	dw Route11GateUpstairsText4
 
 Route11GateUpstairsText1: ; 4945f (12:545f)
 	db $08 ; asm
@@ -77389,7 +78811,7 @@ Route11GateUpstairsObject: ; 0x494da (size=30)
 Route12Gate_h: ; 0x494f8 to 0x49504 (12 bytes) (id=87)
 	db $0c ; tileset
 	db ROUTE_12_GATE_HEIGHT, ROUTE_12_GATE_WIDTH ; dimensions (y, x)
-	dw Route12GateBlocks, Route12GateTexts, Route12GateScript ; blocks, texts, scripts
+	dw Route12GateBlocks, Route12GateTextPointers, Route12GateScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw Route12GateObject ; objects
@@ -77397,7 +78819,7 @@ Route12Gate_h: ; 0x494f8 to 0x49504 (12 bytes) (id=87)
 Route12GateScript: ; 49504 (12:5504)
 	jp EnableAutoTextBoxDrawing
 
-Route12GateTexts: ; 49507 (12:5507)
+Route12GateTextPointers: ; 49507 (12:5507)
 	dw Route12GateText1
 
 Route12GateText1: ; 49509 (12:5509)
@@ -77432,7 +78854,7 @@ Route12GateBlocks: ; 49540 (12:5540)
 Route12GateUpstairs_h: ; 0x49554 to 0x49560 (12 bytes) (id=195)
 	db $0c ; tileset
 	db ROUTE_12_GATE_2F_HEIGHT, ROUTE_12_GATE_2F_WIDTH ; dimensions (y, x)
-	dw Route12GateUpstairsBlocks, Route12GateUpstairsTexts, Route12GateUpstairsScript ; blocks, texts, scripts
+	dw Route12GateUpstairsBlocks, Route12GateUpstairsTextPointers, Route12GateUpstairsScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw Route12GateUpstairsObject ; objects
@@ -77440,8 +78862,10 @@ Route12GateUpstairs_h: ; 0x49554 to 0x49560 (12 bytes) (id=195)
 Route12GateUpstairsScript: ; 49560 (12:5560)
 	jp DisableAutoTextBoxDrawing
 
-Route12GateUpstairsTexts: ; 49563 (12:5563)
-	dw Route12GateUpstairsText1, Route12GateUpstairsText2, Route12GateUpstairsText3
+Route12GateUpstairsTextPointers: ; 49563 (12:5563)
+	dw Route12GateUpstairsText1
+	dw Route12GateUpstairsText2
+	dw Route12GateUpstairsText3
 
 Route12GateUpstairsText1: ; 49569 (12:5569)
 	db $08 ; asm
@@ -77534,7 +78958,7 @@ Route12GateUpstairsObject: ; 0x495de (size=24)
 Route15Gate_h: ; 0x495f6 to 0x49602 (12 bytes) (id=184)
 	db $0c ; tileset
 	db ROUTE_15_GATE_1F_HEIGHT, ROUTE_15_GATE_1F_WIDTH ; dimensions (y, x)
-	dw Route15GateBlocks, Route15GateTexts, Route15GateScript ; blocks, texts, scripts
+	dw Route15GateBlocks, Route15GateTextPointers, Route15GateScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw Route15GateObject ; objects
@@ -77542,7 +78966,7 @@ Route15Gate_h: ; 0x495f6 to 0x49602 (12 bytes) (id=184)
 Route15GateScript: ; 49602 (12:5602)
 	jp EnableAutoTextBoxDrawing
 
-Route15GateTexts: ; 49605 (12:5605)
+Route15GateTextPointers: ; 49605 (12:5605)
 	dw Route15GateText1
 
 Route15GateText1: ; 49607 (12:5607)
@@ -77574,7 +78998,7 @@ Route15GateObject: ; 0x4960c (size=50)
 Route15GateUpstairs_h: ; 4963e (12:563e)
 	db $0c ; tileset
 	db ROUTE_15_GATE_2F_HEIGHT, ROUTE_15_GATE_2F_WIDTH ; dimensions (y, x)
-	dw Route15GateUpstairsBlocks, Route15GateUpstairsTexts, Route15GateUpstairsScript ; blocks, texts, scripts
+	dw Route15GateUpstairsBlocks, Route15GateUpstairsTextPointers, Route15GateUpstairsScript ; blocks, texts, scripts
 	;dw 40db, 564d, 564a ; blocks, texts, scripts
 	db $00 ; connections
 	dw Route15GateUpstairsObject ; objects
@@ -77582,7 +79006,7 @@ Route15GateUpstairs_h: ; 4963e (12:563e)
 Route15GateUpstairsScript: ; 4964a (12:564a)
 	jp DisableAutoTextBoxDrawing
 
-Route15GateUpstairsTexts: ; 4964d (12:564d)
+Route15GateUpstairsTextPointers: ; 4964d (12:564d)
 	dw Route15GateUpstairsText1
 	dw Route15GateUpstairsText2
 
@@ -77645,7 +79069,7 @@ Route15GateUpstairsObject: ; 4969d (12:569d)
 Route16GateMap_h: ; 0x496b2 to 0x496be (12 bytes) (id=186)
 	db $0c ; tileset
 	db ROUTE_16_GATE_1F_HEIGHT, ROUTE_16_GATE_1F_WIDTH ; dimensions (y, x)
-	dw Route16GateMapBlocks, Route16GateMapTexts, Route16GateMapScript ; blocks, texts, scripts
+	dw Route16GateMapBlocks, Route16GateMapTextPointers, Route16GateMapScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw Route16GateMapObject ; objects
@@ -77655,18 +79079,19 @@ Route16GateMapScript: ; 496be (12:56be)
 	res 5, [hl]
 	call EnableAutoTextBoxDrawing
 	ld a, [W_ROUTE16GATECURSCRIPT]
-	ld hl, Route16GateMapScripts
+	ld hl, Route16GateMapScriptPointers
 	jp CallFunctionInTable
 
-Route16GateMapScripts: ; 496cf (12:56cf)
+Route16GateMapScriptPointers: ; 496cf (12:56cf)
 	dw Route16GateMapScript0
-
-INCBIN "baserom.gbc",$496d1,$496d7 - $496d1
+	dw Route16GateMapScript1
+	dw Route16GateMapScript2
+	dw Route16GateMapScript3
 
 Route16GateMapScript0: ; 496d7 (12:56d7)
 	call Func_49755
 	ret nz
-	ld hl, Unknown_49714 ; $5714
+	ld hl, CoordsData_49714
 	call ArePlayerCoordsInArray
 	ret nc
 	ld a, $3
@@ -77694,15 +79119,53 @@ Route16GateMapScript0: ; 496d7 (12:56d7)
 	ld [W_ROUTE16GATECURSCRIPT], a
 	ret
 
-Unknown_49714: ; 49714 (12:5714)
-INCBIN "baserom.gbc",$49714,$49755 - $49714
+CoordsData_49714: ; 49714 (12:5714)
+	db $07,$04
+	db $08,$04
+	db $09,$04
+	db $0A,$04
+	db $FF
+
+Route16GateMapScript1: ; 4971d (12:571d)
+	ld a, [$cd38]
+	and a
+	ret nz
+	ld a, $f0
+	ld [wJoypadForbiddenButtonsMask], a
+
+Route16GateMapScript2: ; 49727 (12:5727)
+	ld a, $1
+	ld [H_SPRITEHEIGHT], a
+	call DisplayTextID
+	ld a, $1
+	ld [$cd38], a
+	ld a, $10
+	ld [$ccd3], a
+	call Func_3486
+	ld a, $3
+	ld [W_ROUTE16GATECURSCRIPT], a
+	ret
+
+Route16GateMapScript3: ; 49741 (12:5741)
+	ld a, [$cd38]
+	and a
+	ret nz
+	xor a
+	ld [wJoypadForbiddenButtonsMask], a
+	ld hl, $d730
+	res 7, [hl]
+	ld a, $0
+	ld [W_ROUTE16GATECURSCRIPT], a
+	ret
 
 Func_49755: ; 49755 (12:5755)
 	ld b, $6
 	jp IsItemInBag
 
-Route16GateMapTexts: ; 4975a (12:575a)
-	dw Route16GateMapText1, Route16GateMapText2, Route16GateMapText3
+Route16GateMapTextPointers: ; 4975a (12:575a)
+	dw Route16GateMapText1
+	dw Route16GateMapText2
+	dw Route16GateMapText3
 
 Route16GateMapText1: ; 49760 (12:5760)
 	db $08 ; asm
@@ -77770,7 +79233,7 @@ Route16GateMapBlocks: ; 497e3 (12:57e3)
 Route16GateUpstairs_h: ; 0x497ff to 0x4980b (12 bytes) (id=187)
 	db $0c ; tileset
 	db ROUTE_16_GATE_2F_HEIGHT, ROUTE_16_GATE_2F_WIDTH ; dimensions (y, x)
-	dw Route16GateUpstairsBlocks, Route16GateUpstairsTexts, Route16GateUpstairsScript ; blocks, texts, scripts
+	dw Route16GateUpstairsBlocks, Route16GateUpstairsTextPointers, Route16GateUpstairsScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw Route16GateUpstairsObject ; objects
@@ -77778,8 +79241,11 @@ Route16GateUpstairs_h: ; 0x497ff to 0x4980b (12 bytes) (id=187)
 Route16GateUpstairsScript: ; 4980b (12:580b)
 	jp DisableAutoTextBoxDrawing
 
-Route16GateUpstairsTexts: ; 4980e (12:580e)
-	dw Route16GateUpstairsText1, Route16GateUpstairsText2, Route16GateUpstairsText3, Route16GateUpstairsText4
+Route16GateUpstairsTextPointers: ; 4980e (12:580e)
+	dw Route16GateUpstairsText1
+	dw Route16GateUpstairsText2
+	dw Route16GateUpstairsText3
+	dw Route16GateUpstairsText4
 
 Route16GateUpstairsText1: ; 49816 (12:5816)
 	db $08 ; asm
@@ -77839,7 +79305,7 @@ Route16GateUpstairsObject: ; 0x4984c (size=30)
 Route18Gate_h: ; 0x4986a to 0x49876 (12 bytes) (id=190)
 	db $0c ; tileset
 	db ROUTE_18_GATE_1F_HEIGHT, ROUTE_18_GATE_1F_WIDTH ; dimensions (y, x)
-	dw Route18GateBlocks, Route18GateTexts, Route18GateScript ; blocks, texts, scripts
+	dw Route18GateBlocks, Route18GateTextPointers, Route18GateScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw Route18GateObject ; objects
@@ -77849,18 +79315,19 @@ Route18GateScript: ; 49876 (12:5876)
 	res 5, [hl]
 	call EnableAutoTextBoxDrawing
 	ld a, [W_ROUTE18GATECURSCRIPT]
-	ld hl, Route18GateScripts
+	ld hl, Route18GateScriptPointers
 	jp CallFunctionInTable
 
-Route18GateScripts: ; 49887 (12:5887)
+Route18GateScriptPointers: ; 49887 (12:5887)
 	dw Route18GateScript0
-
-INCBIN "baserom.gbc",$49889,$4988f - $49889
+	dw Route18GateScript1
+	dw Route18GateScript2
+	dw Route18GateScript3
 
 Route18GateScript0: ; 4988f (12:588f)
 	call Func_49755
 	ret nz
-	ld hl, Unknown_498cc ; $58cc
+	ld hl, CoordsData_498cc
 	call ArePlayerCoordsInArray
 	ret nc
 	ld a, $2
@@ -77888,11 +79355,48 @@ Route18GateScript0: ; 4988f (12:588f)
 	ld [W_ROUTE18GATECURSCRIPT], a
 	ret
 
-Unknown_498cc: ; 498cc (12:58cc)
-INCBIN "baserom.gbc",$498cc,$4990d - $498cc
+CoordsData_498cc: ; 498cc (12:58cc)
+	db $03,$04
+	db $04,$04
+	db $05,$04
+	db $06,$04
+	db $FF
 
-Route18GateTexts: ; 4990d (12:590d)
-	dw Route18GateText1, Route18GateText2
+Route18GateScript1: ; 498d5 (12:58d5)
+	ld a, [$cd38]
+	and a
+	ret nz
+	ld a, $f0
+	ld [wJoypadForbiddenButtonsMask], a
+
+Route18GateScript2: ; 498df (12:58df)
+	ld a, $1
+	ld [H_SPRITEHEIGHT], a
+	call DisplayTextID
+	ld a, $1
+	ld [$cd38], a
+	ld a, $10
+	ld [$ccd3], a
+	call Func_3486
+	ld a, $3
+	ld [W_ROUTE18GATECURSCRIPT], a
+	ret
+
+Route18GateScript3: ; 498f9 (12:58f9)
+	ld a, [$cd38]
+	and a
+	ret nz
+	xor a
+	ld [wJoypadForbiddenButtonsMask], a
+	ld hl, $d730
+	res 7, [hl]
+	ld a, $0
+	ld [W_ROUTE18GATECURSCRIPT], a
+	ret
+
+Route18GateTextPointers: ; 4990d (12:590d)
+	dw Route18GateText1
+	dw Route18GateText2
 
 Route18GateText1: ; 49911 (12:5911)
 	db $08 ; asm
@@ -77944,7 +79448,7 @@ Route18GateObject: ; 0x49937 (size=50)
 Route18GateUpstairs_h: ; 0x49969 to 0x49975 (12 bytes) (id=191)
 	db $0c ; tileset
 	db ROUTE_18_GATE_2F_HEIGHT, ROUTE_18_GATE_2F_WIDTH ; dimensions (y, x)
-	dw Route18GateUpstairsBlocks, Route18GateUpstairsTexts, Route18GateUpstairsScript ; blocks, texts, scripts
+	dw Route18GateUpstairsBlocks, Route18GateUpstairsTextPointers, Route18GateUpstairsScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw Route18GateUpstairsObject ; objects
@@ -77952,8 +79456,10 @@ Route18GateUpstairs_h: ; 0x49969 to 0x49975 (12 bytes) (id=191)
 Route18GateUpstairsScript: ; 49975 (12:5975)
 	jp DisableAutoTextBoxDrawing
 
-Route18GateUpstairsTexts: ; 49978 (12:5978)
-	dw Route18GateUpstairsText1, Route18GateUpstairsText2, Route18GateUpstairsText3
+Route18GateUpstairsTextPointers: ; 49978 (12:5978)
+	dw Route18GateUpstairsText1
+	dw Route18GateUpstairsText2
+	dw Route18GateUpstairsText3
 
 Route18GateUpstairsText1: ; 4997e (12:597e)
 	db $08 ; asm
@@ -78000,7 +79506,7 @@ Route18GateUpstairsObject: ; 0x499a4 (size=24)
 MtMoon1_h: ; 0x499bc to 0x499c8 (12 bytes) (id=59)
 	db $11 ; tileset
 	db MT_MOON_1_HEIGHT, MT_MOON_1_WIDTH ; dimensions (y, x)
-	dw MtMoon1Blocks, MtMoon1Texts, MtMoon1Script ; blocks, texts, scripts
+	dw MtMoon1Blocks, MtMoon1TextPointers, MtMoon1Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw MtMoon1Object ; objects
@@ -78008,17 +79514,32 @@ MtMoon1_h: ; 0x499bc to 0x499c8 (12 bytes) (id=59)
 MtMoon1Script: ; 499c8 (12:59c8)
 	call EnableAutoTextBoxDrawing
 	ld hl, MtMoon1TrainerHeader0
-	ld de, Unknown_59db
+	ld de, MtMoon1ScriptPointers
 	ld a, [W_MTMOON1CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_MTMOON1CURSCRIPT], a
 	ret
 
-Unknown_59db: ; 499db (12:59db)
-INCBIN "baserom.gbc",$499db,$499e1 - $499db
+MtMoon1ScriptPointers: ; 499db (12:59db)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-MtMoon1Texts: ; 499e1 (12:59e1)
-	dw MtMoon1Text1, MtMoon1Text2, MtMoon1Text3, MtMoon1Text4, MtMoon1Text5, MtMoon1Text6, MtMoon1Text7, Predef5CText, Predef5CText, Predef5CText, Predef5CText, Predef5CText, Predef5CText, MtMoon1Text14
+MtMoon1TextPointers: ; 499e1 (12:59e1)
+	dw MtMoon1Text1
+	dw MtMoon1Text2
+	dw MtMoon1Text3
+	dw MtMoon1Text4
+	dw MtMoon1Text5
+	dw MtMoon1Text6
+	dw MtMoon1Text7
+	dw Predef5CText
+	dw Predef5CText
+	dw Predef5CText
+	dw Predef5CText
+	dw Predef5CText
+	dw Predef5CText
+	dw MtMoon1Text14
 
 MtMoon1TrainerHeaders: ; 499fd (12:59fd)
 MtMoon1TrainerHeader0: ; 499fd (12:59fd)
@@ -78084,7 +79605,7 @@ MtMoon1TrainerHeader7: ; 49a45 (12:5a45)
 	dw MtMoon1EndBattleText8 ; 0x5af7 TextEndBattle
 	dw MtMoon1EndBattleText8 ; 0x5af7 TextEndBattle
 
-db $ff
+	db $ff
 
 MtMoon1Text1: ; 49a52 (12:5a52)
 	db $08 ; asm
